
#define NOiD_free 999999990
#define NOiD_root 999999991
#define NOiD_file 999999992
#define NOiD_dodo 999999998
#define NOiD_eran 999999999

typedef unsigned long int NOiD_id;

typedef struct NOiD_fs
{
	NOiD_id id;
	NOiD_id nfo;
	NOiD_id undo;
	NOiD_id redo;
	NOiD_id back;
	NOiD_id fore;
	NOiD_id last;
	NOiD_id next;
} NOiD_fs;

//===============================================================================================
//===============================================================================================
//===============================================================================================
//===============================================================================================

NOiD_fs * NOiD_get_node (NOiD_fs * noid_table, NOiD_id noid_numb)
/* internal function */
{
	return (NOiD_fs*)(((void*)noid_table) + (noid_numb * sizeof(NOiD_fs)));
}

/* will make the table in memory but will keep space for himself */
NOiD_fs * NOiD_build (int noid_qty, int noid_cluster, void * noid_ptr)
{
	if ((noid_cluster <= sizeof(NOiD_fs))||(noid_ptr == 0)||(noid_qty == 0))
	{	return 0;	}

	NOiD_fs * noid_root_node = (NOiD_fs*)noid_ptr;
	noid_root_node->id = 0;
	noid_root_node->nfo = NOiD_root;

	NOiD_fs * noid_cluster_node;
	int noid_table_clusters = ((noid_qty * sizeof(NOiD_fs)) + sizeof(NOiD_fs)-1) /noid_cluster;
	int noid_cluster_id = 1;
	while (noid_cluster_id < noid_qty)
	{
		noid_cluster_node = (NOiD_fs*)(noid_ptr + (noid_cluster_id * sizeof(NOiD_fs)));
		noid_cluster_node->id = noid_cluster_id;
		if (noid_cluster_id < noid_table_clusters)
		{
			NOiD_fs * noid_back_node;
			noid_cluster_node->nfo = NOiD_file;

			noid_cluster_node->back = noid_root_node->back;
			noid_cluster_node->fore = noid_root_node->id;
			noid_back_node = NOiD_get_node(noid_root_node, noid_root_node->back);
			noid_root_node->back = noid_cluster_node->id;
			noid_back_node->fore = noid_cluster_node->id;
			noid_cluster_node->last = noid_cluster_node->id;
			noid_cluster_node->next = noid_cluster_node->id;
			noid_cluster_node->undo = noid_cluster_node->id;
			noid_cluster_node->redo = noid_cluster_node->id;
			
		}
		else
		{
			NOiD_fs * noid_undo_node;
			noid_cluster_node->nfo = NOiD_free;

			noid_cluster_node->redo = noid_root_node->id;
			noid_cluster_node->undo = noid_root_node->undo;
			noid_undo_node = NOiD_get_node(noid_root_node, noid_root_node->undo);
			noid_root_node->undo = noid_cluster_node->id;
			noid_undo_node->redo = noid_cluster_node->id;
			noid_cluster_node->last = noid_cluster_node->id;
			noid_cluster_node->next = noid_cluster_node->id;
			noid_cluster_node->back = noid_cluster_node->id;
			noid_cluster_node->fore = noid_cluster_node->id;
		}

		noid_cluster_id += 1;
	}

	return noid_root_node;
}

/* just in the case you build ure fs in ram 
   this will act has harddrive form */
void * NOiD_read (NOiD_fs * noid_table, NOiD_id noid_size, NOiD_id noid_numb, void * noid_dest)
{
	int noid_down = noid_size;
	while (noid_down != 0)
	{
		*(char*)(noid_dest + noid_down) = *(char*)(((void*)noid_table) + (noid_numb * noid_size) + noid_down);
		noid_down -= 1;
	}
	return noid_dest;
}

/* just in the case you build ure fs in ram 
   this will act has harddrive form */
void * NOiD_write (NOiD_fs * noid_table, NOiD_id noid_size, NOiD_id noid_numb, void * noid_src)
{
	int noid_down = noid_size;
	while (noid_down != 0)
	{
		*(char*)(((void*)noid_table) + (noid_numb * noid_size) + noid_down) = *(char*)(noid_src + noid_down);
		noid_down -= 1;
	}
	return noid_src;
}


//===============================================================================================
//===============================================================================================
//===============================================================================================
//===============================================================================================

NOiD_id NOiD_push (NOiD_fs * noid_table ,NOiD_id noid_file ,NOiD_id noid_eran)
{
	if ((noid_table == 0)||(noid_file == 0)||(noid_eran == 0))
	{
		return 0;
	}



	return 0;
}

/* pop cluster from file if there is a redo to replace it
   useful if you undo the file cluster and want to keep it
   somewhere, then the first redo will take place */
NOiD_id NOiD_pop (NOiD_fs * noid_table ,NOiD_id noid_file)
{
	if (noid_table == 0)
	{	return 0;	}

	int noid_new_id;
	NOiD_fs * noid_new_eran;
	if (noid_file == 0)
	{
		NOiD_fs * noid_root_node = NOiD_get_node (noid_table, 0);
		noid_new_eran = NOiD_get_node(noid_table, noid_root_node->undo);
		NOiD_fs * noid_new_undo = NOiD_get_node(noid_table, noid_new_eran->undo);
		noid_root_node->undo = noid_new_undo->id;
		noid_new_undo->redo = noid_root_node->id;
		noid_new_eran->undo = noid_new_eran->id;
		noid_new_eran->redo = noid_new_eran->id;
		noid_new_eran->nfo = NOiD_eran;
		noid_new_id = noid_new_eran->id;
	}
	else
	{
		noid_new_eran = NOiD_get_node (noid_table, noid_file);
		if ((noid_new_eran->undo == noid_new_eran->id)||(noid_new_eran->redo == noid_new_eran->id))
		{
			NOiD_fs * noid_back_file = NOiD_get_node (noid_table, noid_new_eran->back);
			NOiD_fs * noid_fore_file = NOiD_get_node (noid_table, noid_new_eran->fore);
			NOiD_fs * noid_last_file = NOiD_get_node (noid_table, noid_new_eran->last);
			NOiD_fs * noid_next_file = NOiD_get_node (noid_table, noid_new_eran->next);
			NOiD_fs * noid_new_file = NOiD_get_node (noid_table, noid_new_eran->redo);
			NOiD_fs * noid_new_undo = NOiD_get_node (noid_table, noid_new_eran->undo);
			noid_new_file->undo = noid_new_undo->id;
			noid_new_undo->redo = noid_new_file->id;
			noid_back_file->fore = noid_new_file->id;
			noid_fore_file->back = noid_new_file->id;
			noid_new_file->back = noid_back_file->id;
			noid_new_file->fore = noid_fore_file->id;
			noid_last_file->next = noid_new_file->id;
			noid_next_file->last = noid_new_file->id;
			noid_new_file->last = noid_last_file->id;
			noid_new_file->next = noid_next_file->id;
			noid_new_eran->undo = noid_new_eran->id;
			noid_new_eran->redo = noid_new_eran->id;
			noid_new_eran->nfo = NOiD_eran;
			noid_new_id = noid_new_eran->id;
		}
		else
		{
			noid_new_eran = 0;
			noid_new_id = 0;
		}
	}

	return noid_new_id;
}

NOiD_id NOiD_undo (NOiD_fs * noid_table ,NOiD_id noid_file)
{
	if ((noid_table == 0)||(noid_file == 0))
	{
		return 0;
	}


	return 0;
}

NOiD_id NOiD_redo (NOiD_fs * noid_table ,NOiD_id noid_file)
{
	if ((noid_table == 0)||(noid_file == 0))
	{
		return 0;
	}

	return 0;
}

//===============================================================================================
//===============================================================================================
//===============================================================================================
//===============================================================================================

/* will make new file from any eran cluster */
NOiD_id NOiD_mk (NOiD_fs * noid_table ,NOiD_id noid_eran)
{
	if ((noid_table == 0)||(noid_eran == 0))
	{	return 0;	}

	NOiD_id noid_new_id = 0;
	NOiD_fs * noid_new_file = NOiD_get_node (noid_table, noid_eran);
	if (noid_new_file->nfo == NOiD_eran)
	{
		NOiD_fs * noid_root_file = NOiD_get_node (noid_table, 0);
		NOiD_fs * noid_last_file = NOiD_get_node (noid_table, noid_root_file->last);
		noid_new_file->last = noid_last_file->id;
		noid_new_file->next = noid_root_file->id;
		noid_last_file->next = noid_new_file->id;
		noid_root_file->last = noid_new_file->id;
		noid_new_file->nfo = NOiD_root;
		noid_new_id = noid_new_file->id;
	}

	return 0;
}

NOiD_id NOiD_rm (NOiD_fs * noid_table ,NOiD_id noid_root)
{
	if ((noid_table == 0)||(noid_root == 0))
	{
		return 0;
	}

	return 0;
}

NOiD_id NOiD_add (NOiD_fs * noid_table ,NOiD_id noid_root ,NOiD_id noid_eran)
{
	if ((noid_table == 0)||(noid_root == 0)||(noid_eran == 0))
	{
		return 0;
	}

	return 0;
}

NOiD_id NOiD_sub (NOiD_fs * noid_table ,NOiD_id noid_root)
{
	if ((noid_table == 0)||(noid_root == 0))
	{
		return 0;
	}

	return 0;
}
//===============================================================================================
//===============================================================================================
//===============================================================================================
//===============================================================================================

NOiD_id NOiD_fore (NOiD_fs * noid_table ,NOiD_id noid_file)
{
	if ((noid_table == 0)||(noid_file == 0))
	{
		return 0;
	}

	return 0;
}

NOiD_id NOiD_back (NOiD_fs * noid_table ,NOiD_id noid_file)
{
	if ((noid_table == 0)||(noid_file == 0))
	{
		return 0;
	}

	return 0;
}

NOiD_id NOiD_next (NOiD_fs * noid_table ,NOiD_id noid_root)
{
	if ((noid_table == 0)||(noid_root == 0))
	{
		return 0;
	}

	return 0;
}

NOiD_id NOiD_last (NOiD_fs * noid_table ,NOiD_id noid_root)
{
	if ((noid_table == 0)||(noid_root == 0))
	{
		return 0;
	}


	return 0;
}

//===============================================================================================
//===============================================================================================
//===============================================================================================
//===============================================================================================
